/*
   Copyright (C) 1999 T. Scott Dattalo

This file is part of gpsim.

gpsim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gpsim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gpsim; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#include <iostream.h>
#include <iomanip.h>
#include <string>

#include "command.h"
#include "cmd_dump.h"

#include "../src/pic-processor.h"
#include "../src/14bit-processors.h"

cmd_dump dump;

static cmd_options cmd_dump_options[] =
{
  "e",1,    OPT_TT_BITFLAG,
  "r",2,    OPT_TT_BITFLAG,
  NULL,0,0
};


cmd_dump::cmd_dump(void)
{ 
  name = "dump";

    brief_doc = string("Display either the RAM or EEPROM");

    long_doc = string ("dump [r | e]\n
\tdump r or dump with no options will display all of the file\n\
\tregisters and special function registers.\n\
\tdump e will display the contents of the eeprom (if the pic
\tbeing simulated contains any\n\
\n");

  op = cmd_dump_options; 
}


void cmd_dump::dump(int bit_flag)
{

  if(!have_cpu(1))
    return;

  switch(bit_flag)
    {
    case 1:
      cpu14->eeprom.dump();   // *** FIX ME *** no cpu14 casting
      break;
    case 2:
      cpu->dump_registers();
      break;
    }
}

void cmd_dump::dump(void)
{
  if(!have_cpu(1))
    return;

  cpu->dump_registers();

}
