
#include <gnome.h>

#include <stdio.h>

#include <iostream.h>

#include "../src/gpsim_def.h"
#include "../src/pic-processor.h"

#define USE_TEMPLATES 1

static gboolean restarted= FALSE;

#ifdef DOING_POPT
static struct poptOption prog_options[] = 
{
	POPT_AUTOHELP
	{NULL, '\0', 0, NULL, 0}
};
#endif

#ifdef DOING_SM
static int save_state (GnomeClient *, gint, GnomeRestartStyle, gint,
		       GnomeInteractStyle, gint, gpointer);
#endif

static void add_cb(GtkWidget *w);
static void remove_cb(GtkWidget *w);
static void add_view_cb(GtkWidget *w);
static void remove_view_cb(GtkWidget *w);
static void quit_cb(GtkWidget *w);
static void about_cb(GtkWidget *w,void *data);
static void mode_top_cb(GtkWidget *w);
static void mode_book_cb(GtkWidget *w);
static void mode_modal_cb(GtkWidget *w);
static void inc_counter_cb(GtkWidget *w, gpointer user_data);

static void app_created_handler(GnomeMDI *, GnomeApp *);

static gchar         *my_child_get_config_string(GnomeMDIChild *, gpointer);
static GnomeMDIChild *my_child_new_from_config (const gchar *);
static GtkWidget     *my_child_set_label(GnomeMDIChild *, GtkWidget *, gpointer);
static GtkWidget     *my_child_create_view(GnomeMDIChild *, gpointer);

/* the template for MDI menus */

GnomeUIInfo file_menu[] = {
	{ GNOME_APP_UI_ITEM, "Add Register Window", NULL, add_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ITEM, "Remove Register Window", NULL, remove_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_SEPARATOR, NULL, NULL, NULL, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ITEM, "Exit", NULL, quit_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXIT, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ENDOFINFO }
};

GnomeUIInfo mode_menu[] = {
	{ GNOME_APP_UI_ITEM, "Notebook", NULL, mode_book_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ITEM, "Toplevel", NULL, mode_top_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ITEM, "Modal", NULL, mode_modal_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ENDOFINFO }
};

GnomeUIInfo help_menu[] = {
	{ GNOME_APP_UI_ITEM, "About gpsim...", NULL, about_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ENDOFINFO }
};

GnomeUIInfo empty_menu[] = {
	{ GNOME_APP_UI_ENDOFINFO }
};

GnomeUIInfo main_menu[] = {
	{ GNOME_APP_UI_SUBTREE, ("File"), NULL, file_menu, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_SUBTREE, ("Children"), NULL, empty_menu, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_SUBTREE, ("MDI Mode"), NULL, mode_menu, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_SUBTREE, ("Help"), NULL, help_menu, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ENDOFINFO }
};


extern GnomeMDI *register_mdi;

#ifdef DOING_SM

GnomeClient *client;

#endif

/* the template for child-specific menus */
GnomeUIInfo child_menu[] = {
	{ GNOME_APP_UI_ITEM, "Add View", NULL, add_view_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ITEM, "Remove View", NULL, remove_view_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_SEPARATOR },
	{ GNOME_APP_UI_ITEM, "Increase Counter", NULL, inc_counter_cb, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },	
	{ GNOME_APP_UI_ENDOFINFO }
};

GnomeUIInfo main_child_menu[] = {
	{ GNOME_APP_UI_SUBTREE, ("Child"), NULL, child_menu, NULL, NULL,
	  GNOME_APP_PIXMAP_NONE, NULL, 0, (GdkModifierType)0, NULL },
	{ GNOME_APP_UI_ENDOFINFO }
};

/*
static GnomeUIInfo toolbar_info[5] = {
	{ GNOME_APP_UI_ITEM, "New", "Create a new file", NULL, NULL, NULL,
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_NEW, 0, 0, NULL },
    { GNOME_APP_UI_ITEM, "Open", "Open an existing file", NULL, NULL, NULL,
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_OPEN, 0, 0, NULL },
    { GNOME_APP_UI_ITEM, "Save", "Save the current file", NULL, NULL, NULL,
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE, 0, 0, NULL },
    { GNOME_APP_UI_ITEM, "Save as", "Save the current file with a new name", NULL, NULL, NULL,
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE_AS, 0, 0, NULL },
    GNOMEUIINFO_END
};

*/

static pic_processor *gui_active_pic=NULL;

GtkWidget *CreateRegisterWindow(pic_processor *newpic);


void add_view(void)
{
  add_view_cb(NULL);
}

/*
 * create_view signal handler: creates any GtkWidget to be used as a view
 * of the child
 */
static GtkWidget *my_child_create_view(GnomeMDIChild *child, gpointer data) 
{
  GtkWidget *new_view;
    gchar label[256];
    gint counter;

  printf("my_child_create_view\n");

  sprintf(label, "Child %d",
	  GPOINTER_TO_INT (gtk_object_get_user_data(GTK_OBJECT(child))));

  //    new_view = gtk_label_new(label);

  new_view = CreateRegisterWindow(gui_active_pic);

  printf("my_child_create_view is done\n");

  return new_view;
}

/*
 * create config string for this child
 */
static gchar *my_child_get_config_string(GnomeMDIChild *child, gpointer data) 
{
  return g_strdup_printf ("%d", GPOINTER_TO_INT (gtk_object_get_user_data(GTK_OBJECT(child))));
}

static GtkWidget *my_child_set_label(GnomeMDIChild *child,
				     GtkWidget *old_label,
				     gpointer data)
{

  printf("my_child_set_label\n");
  GtkWidget *hbox, *pixmap, *label;
  if(old_label == NULL) {
    /* if old_label is NULL, we have to create a new label */
    hbox = gtk_hbox_new(FALSE, 0);
    label = gtk_label_new(child->name);
    gtk_widget_show(label);
    
    pixmap = gnome_stock_new_with_icon(GNOME_STOCK_MENU_TRASH_FULL);
    gtk_widget_show(pixmap);
    gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 2);
    
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
  }
  else {
    hbox = old_label;
    /* old_label is a hbox we created once */
    label = GTK_WIDGET(g_list_next(gtk_container_children(GTK_CONTAINER(old_label)))->data);
    if(label)
      gtk_label_set_text(GTK_LABEL(label), child->name);
  }

  return hbox;
}

static GnomeMDIChild *my_child_new_from_config (const gchar *string) 
{
  GnomeMDIGenericChild *child;
  gchar *name;
  gint c;
	
  if (sscanf (string, "%d", &c) != 1)
    return NULL;
	
  name = g_strdup_printf("Child %d", c);

  if((child = gnome_mdi_generic_child_new(name)) != NULL) {
    gnome_mdi_generic_child_set_view_creator(child, my_child_create_view, NULL);
	  
    gnome_mdi_child_set_menu_template(GNOME_MDI_CHILD(child), main_child_menu);
    gnome_mdi_generic_child_set_config_func(child, my_child_get_config_string, NULL);
    gnome_mdi_generic_child_set_label_func(child, my_child_set_label, NULL);

    gtk_object_set_user_data(GTK_OBJECT(child), GINT_TO_POINTER(c));
  }

  return GNOME_MDI_CHILD (child);
}

static void quit_cb (GtkWidget *widget) {
	/* when the user wants to quit we try to remove all children and if we
	   succeed destroy the MDI. if TRUE was passed as the second (force)
	   argument, remove_child signal wouldn't be emmited.
	*/
  if(gnome_mdi_remove_all(register_mdi, FALSE))
    gtk_object_destroy(GTK_OBJECT(register_mdi));
}

static void cleanup_cb(GnomeMDI *mdi) {
	/* on destruction of GnomeMDI we call gtk_main_quit(), since we have opened
	   no windows on our own and therefore our GUI is gone.
	*/
	gtk_main_quit();
}

static void add_view_cb(GtkWidget *w) {
	/* our child-menu-item activate signal handler also gets the pointer to
	   the child that this menu item belongs to as the second argument
	*/
  GnomeMDIChild *child;

  if(register_mdi->active_view) {
    child = gnome_mdi_get_child_from_view(register_mdi->active_view);
    gnome_mdi_add_view(register_mdi, child);
  }
}

static void remove_view_cb(GtkWidget *w) {
	/* mdi->active_view holds the pointer to the view that this action
	   applies to
	*/
	if(register_mdi->active_view)
		gnome_mdi_remove_view(register_mdi, register_mdi->active_view, FALSE);
}

static void remove_cb(GtkWidget *w) {
	/* register_mdi->active_child holds the pointer to the child that this action
	   applies to
	*/
  if(register_mdi->active_view)
    gnome_mdi_remove_child(register_mdi, 
			   gnome_mdi_get_child_from_view(register_mdi->active_view),
			   FALSE);
}

static void add_cb(GtkWidget *w) {
	static gint counter = 1;
	gchar name[32];
	GnomeMDIGenericChild *child;

	printf("add_cb\n");
	sprintf(name, "Child %d", counter);
	
	if((child = gnome_mdi_generic_child_new(name)) != NULL) {
		printf("add_cb set view\n");
		gnome_mdi_generic_child_set_view_creator(child, my_child_create_view, NULL);
		printf("add_cb set menu\n");
		gnome_mdi_child_set_menu_template(GNOME_MDI_CHILD(child), main_child_menu);
		printf("add_cb set config func\n");
		gnome_mdi_generic_child_set_config_func(child, my_child_get_config_string, NULL);
		printf("add_cb set label func\n");
		gnome_mdi_generic_child_set_label_func(child, my_child_set_label, NULL);

		printf("add_cb set user data\n");
		gtk_object_set_user_data(GTK_OBJECT(child), GINT_TO_POINTER(counter));

		/* add the child to MDI */
		printf("add_cb add child\n");
		gnome_mdi_add_child(register_mdi, GNOME_MDI_CHILD(child));
		
		/* and add a new view of the child */
		printf("add_cb add view\n");
		gnome_mdi_add_view(register_mdi, GNOME_MDI_CHILD(child));

		counter++;
	}
}

static void inc_counter_cb(GtkWidget *w, gpointer user_data) {
	GnomeMDIGenericChild *child = GNOME_MDI_GENERIC_CHILD(user_data);
	gchar name[32];
	gint counter;
	GList *view;

	counter = GPOINTER_TO_INT (gtk_object_get_user_data(GTK_OBJECT(child)));
	counter++;
	gtk_object_set_user_data(GTK_OBJECT(child), GINT_TO_POINTER (counter));

	sprintf(name, "Child %d", counter);
	gnome_mdi_child_set_name(GNOME_MDI_CHILD(child), name);

	/* update views */
	view = GNOME_MDI_CHILD(child)->views;
	while(view) {
		gtk_label_set_text(GTK_LABEL(view->data), name);
		view = view->next;
	}
}

static void mode_top_cb(GtkWidget *w) {
	gnome_mdi_set_mode(register_mdi, GNOME_MDI_TOPLEVEL);
}

static void mode_book_cb(GtkWidget *w) {
	gnome_mdi_set_mode(register_mdi, GNOME_MDI_NOTEBOOK);
}

static void mode_modal_cb(GtkWidget *w) {
	gnome_mdi_set_mode(register_mdi, GNOME_MDI_MODAL);
}

static void
about_cb (GtkWidget *widget, void *data)
{
	GtkWidget *about;
	const gchar *authors[] = {
		"Scott Dattalo - sdattalo@interstice.com | sdattalo@unix.sri.com",
		NULL
	};
	
	about = gnome_about_new ( "The GNUPIC Simulator - ", GPSIM_VERSION,
				  /* copyright notice */
				  "(C) 1999 ",
				  authors,
				  /* another comments */
				  "A simulator for Microchip PIC microcontrollers.",
				  NULL);
	gtk_widget_show (about);
	
	return;
}
static void reply_handler(gint reply, gpointer data) {
	gint *int_data = (gint *)data;
	*int_data = reply;
	gtk_main_quit();
}

static gint remove_child_handler(GnomeMDI *mdi, GnomeMDIChild *child) {
	gchar question[128];
	gint reply;

	sprintf(question, "Do you really want to remove child %d\n",
			GPOINTER_TO_INT (gtk_object_get_user_data(GTK_OBJECT(child))));

	gnome_app_question_modal(gnome_mdi_get_active_window(mdi), question,
							 reply_handler, &reply);

	/* I hope increasing main_level is the proper way to stop an app until
	   user had replied to this question... */
	gtk_main();

	if(reply == 0)
		return TRUE;

	return FALSE;
}


void app_created_handler(GnomeMDI *mdi, GnomeApp *app) {

}

void mdi_init(void) {

	gboolean restart_ok = FALSE;

	/* gnome_init() is always called at the beginning of a program.  it
	   takes care of initializing both Gtk and GNOME.  It also parses
	   the command-line arguments.  */
	register_mdi = GNOME_MDI(gnome_mdi_new("gnome-hello-7-mdi", "GNOME MDI Hello"));

	/* set up MDI menus: note that GnomeMDI will copy this struct for its own use, so
	   main_menu[] will remain intact */
	gnome_mdi_set_menubar_template(register_mdi, main_menu);
	//	gnome_mdi_set_toolbar_template(register_mdi, toolbar_info);

	/* and document menu and document list paths (see gnome-app-helper menu
	   insertion routines for details)  */
	gnome_mdi_set_child_menu_path(register_mdi, _("File"));
	gnome_mdi_set_child_list_path(register_mdi, _("Children/"));

	/* connect signals */
	gtk_signal_connect(GTK_OBJECT(register_mdi), "destroy",
					   GTK_SIGNAL_FUNC(cleanup_cb), NULL);
	gtk_signal_connect(GTK_OBJECT(register_mdi), "remove_child",
					   GTK_SIGNAL_FUNC(remove_child_handler), NULL);
	gtk_signal_connect(GTK_OBJECT(register_mdi), "app_created",
					   GTK_SIGNAL_FUNC(app_created_handler), NULL);
	
	/* we could also connect handlers to other signals, but since we're lazy, we won't ;) */

		gnome_mdi_open_toplevel(register_mdi);

	/* and here we go... */
	//	gtk_main();

	//	return 0;
}
