#include <stdio.h>
#include <stdlib.h>
#include <sys/errno.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib.h>
#include <string.h>
#include <iostream.h>

#include "gtksheet/gtkcombobox.h"
#include "gtksheet/gtkbordercombo.h"
#include "gtksheet/gtkcolorcombo.h"
#include "gtksheet/gtksheet.h"
#include "gtksheet/gtksheetentry.h"

#include "../src/gpsim_def.h"
#include "../src/pic-processor.h"
#include "gui.h"

#define USE_DEMO_TOOLBAR 1

#define DEFAULT_PRECISION 3
#define DEFAULT_SPACE 8

GtkWidget *window;
//GtkWidget *main_vbox;
//GtkWidget *notebook;
//GtkWidget **sheets;

GtkWidget *register_sheet;
GtkWidget *entry;
GtkWidget *status_box;
GtkWidget *location;

#ifdef USE_DEMO_TOOLBAR
GtkWidget *show_hide_box;


GtkWidget *fgcolorcombo;
GtkWidget *bgcolorcombo;
GtkWidget *bordercombo;
GdkPixmap *pixmap;
GdkBitmap *mask;
GtkWidget *bg_pixmap;
GtkWidget *fg_pixmap;
static GtkWidget *toolbar;

GtkWidget *left_button;
GtkWidget *center_button;
GtkWidget *right_button;
GtkWidget *tpixmap;

#endif

extern GUI_Processor *gp;
extern GtkStyle *normal_style;
extern GdkColor item_has_changed_color;
extern GdkColor normal_fg_color;
extern GdkColor normal_bg_color;
extern GdkColor breakpoint_color;

static char *items[]={
	"Clear Range",
	"Fill Range",
	"Break on Read",
	"Break on Write",
	"Break"

};

Register_Window *register_window;

void fill_range (void);
void exit_gpsim(void);

//void get_main_popup (GtkWidget *main_window, GtkWidget ** menu);

void assign_register_value(Register_Window *rw, unsigned int reg_number,unsigned int value);

extern StatusBar_Window *status_bar_window;

void StatusBar_create(GtkWidget *vbox_main, StatusBar_Window *sbw);
void update_ascii(Register_Window *rw, gint row);

void RegWindow_update(Register_Window *rw);
extern int SourceBrowser_change_view (struct _gui_object *_this, int view_state);

/*
void
quit ()
{
  gtk_main_quit();
}
*/

static void
popup_activated(GtkWidget *widget, gpointer data)
{
 GtkSheet *sheet;

 gchar *item;

 sheet=GTK_SHEET(register_sheet);

 item = (gchar *)data;
 /*
 if(strcmp(item,"Clear Range")==0)
   fill_range();

 if(strcmp(item,"Add Row")==0)
   gtk_sheet_add_row(sheet,1);

 if(strcmp(item,"Insert Row")==0){
   if(sheet->state==GTK_SHEET_ROW_SELECTED)
     gtk_sheet_insert_rows(sheet,sheet->range.row0,                       
                               sheet->range.rowi-sheet->range.row0+1);

 }

 if(strcmp(item,"Insert Column")==0){
   if(sheet->state==GTK_SHEET_COLUMN_SELECTED)
     gtk_sheet_insert_columns(sheet,sheet->range.col0,                       
                              sheet->range.coli-sheet->range.col0+1);

 } 

 if(strcmp(item,"Delete Row")==0){
   if(sheet->state==GTK_SHEET_ROW_SELECTED)
     gtk_sheet_delete_rows(sheet,sheet->range.row0,
                              sheet->range.rowi-sheet->range.row0+1);
 }

 if(strcmp(item,"Delete Column")==0){
   if(sheet->state==GTK_SHEET_COLUMN_SELECTED)
     gtk_sheet_delete_columns(sheet,sheet->range.col0,
                              sheet->range.coli-sheet->range.col0+1);   
 } 

 if(strcmp(item,"Clear Cells")==0){
   if(sheet->state!=GTK_SHEET_NORMAL)
     gtk_sheet_range_clear(sheet, &sheet->range);
 } 
 */

}


#if 0

/*
 * GtkHandleBox
 */

static void
handle_box_child_signal (GtkHandleBox *hb,
			 GtkWidget    *child,
			 const gchar  *action)
{
  printf ("%s: child <%s> %sed\n",
	  gtk_type_name (GTK_OBJECT_TYPE (hb)),
	  gtk_type_name (GTK_OBJECT_TYPE (child)),
	  action);
}

static void
create_handle_box ( GtkWidget* vbox)
{
  static
  GtkWidget *handle_box;
  GtkWidget *hbox;
//  GtkWidget *toolbar;
  GtkWidget *label;
	
  if (!window)
	  return;


    hbox = gtk_hbox_new (FALSE, 10);
    gtk_container_add (GTK_CONTAINER (vbox), hbox);
    gtk_widget_show (hbox);

    handle_box = gtk_handle_box_new ();

    gtk_box_pack_start (GTK_BOX (hbox), handle_box, FALSE, FALSE, 0);

    gtk_signal_connect (GTK_OBJECT (handle_box),
			"child_attached",
			GTK_SIGNAL_FUNC (handle_box_child_signal),
			"attached");

    gtk_signal_connect (GTK_OBJECT (handle_box),
			"child_detached",
			GTK_SIGNAL_FUNC (handle_box_child_signal),
			"detached");

    gtk_widget_show (handle_box);

/*
    toolbar = make_toolbar (window);
    gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NORMAL);
    gtk_container_add (GTK_CONTAINER (handle_box), toolbar);
    gtk_widget_show (toolbar);
*/

    label = gtk_label_new ("Fooo!");
    gtk_container_add (GTK_CONTAINER (handle_box), label);
    gtk_widget_show (label);


}

#endif


static GtkWidget *
build_menu(GtkWidget *sheet)
{
  GtkWidget *menu;
  GtkWidget *item;
  int i;

  //  get_main_popup(sheet, &menu);


  menu=gtk_menu_new();

  for (i=0; i < (sizeof(items)/sizeof(items[0])) ; i++){
    item=gtk_menu_item_new_with_label(items[i]);
    /*
      gtk_signal_connect(GTK_OBJECT(item),"activate",
      (GtkSignalFunc) popup_activated,
      items[i]);
      GTK_WIDGET_SET_FLAGS (item, GTK_SENSITIVE | GTK_CAN_FOCUS);
      switch(i){
      case 2:
      if(GTK_SHEET(sheet)->state!=GTK_SHEET_ROW_SELECTED)
      GTK_WIDGET_UNSET_FLAGS (item, 
      GTK_SENSITIVE | GTK_CAN_FOCUS);
      break;
      case 3:
      if(GTK_SHEET(sheet)->state!=GTK_SHEET_COLUMN_SELECTED)
      GTK_WIDGET_UNSET_FLAGS (item, 
      GTK_SENSITIVE | GTK_CAN_FOCUS);
      break;
      case 4:
      if(GTK_SHEET(sheet)->state!=GTK_SHEET_ROW_SELECTED)
      GTK_WIDGET_UNSET_FLAGS (item, 
      GTK_SENSITIVE | GTK_CAN_FOCUS);
      break;
      case 5:
      if(GTK_SHEET(sheet)->state!=GTK_SHEET_COLUMN_SELECTED)
      GTK_WIDGET_UNSET_FLAGS (item, 
      GTK_SENSITIVE | GTK_CAN_FOCUS);
      break;
      } 
    */

    gtk_widget_show(item);
    gtk_menu_append(GTK_MENU(menu),item);
  }

  return menu;
}

static gint
do_popup(GtkWidget *widget, GdkEventButton *event, gpointer data)
{

	static GtkWidget *popup;
	GdkModifierType mods;
	GtkSheet *sheet;

	sheet=GTK_SHEET(widget);


	if( (event->type == GDK_BUTTON_PRESS) &&  (event->button == 3) ) 
	{
 
		if(popup)
			g_free(popup);

		if (event->window == sheet->column_title_window )
		  //printf("popup column window\n");
		  return TRUE;
		else if (event->window == sheet->row_title_window )
		  //printf("popup  window\n");
		  return TRUE;
		else

		  popup=build_menu(widget);

		gtk_menu_popup(GTK_MENU(popup), NULL, NULL, NULL, NULL,
			       3, event->time);

	}

	return FALSE;
}
  /*

void
format_text (GtkSheet *sheet, int *justification, gchar *text, char *label)
{
  double auxval;
  int digspace=0;
  int cell_width, char_width;
  double val;
  int format;
  double space;
  int intspace;
  int nonzero=FALSE;
  int ipos;
  char nchar;
  enum {EMPTY, TEXT, NUMERIC};

  cell_width=sheet->column[sheet->active_cell.col].width;
  char_width = gdk_char_width (GTK_WIDGET(sheet)->style->font,(gchar)'X');
  space= (double)cell_width/(double)char_width;

  intspace=(int)MIN(space, (double)DEFAULT_SPACE);

  format=EMPTY;
  if(strlen(text) != 0)
  { 
        for(ipos=0; ipos<strlen(text); ipos++){

          switch(nchar=text[ipos]){
           case '.':
           case ' ': case ',':
           case '-': case '+':
           case 'd': case 'D':
           case 'E': case 'e':
           case '1': case '2': case '3': case '4': case '5': case '6':
           case '7': case '8': case '9':
            nonzero=TRUE;
            break;
           case '0':
            break;
           default:
            format=TEXT;
          }
          if(format != EMPTY) break;
        }
        val=atof(text);
        if(format!=EMPTY || (val==0. && nonzero))
             format = TEXT;
        else
             format = NUMERIC;
  }

  switch(format){
    case TEXT:
    case EMPTY:
      strcpy(label, text);
      return;
    case NUMERIC:
      val=atof(text);
      *justification = GTK_JUSTIFY_RIGHT;
  }

  auxval= val < 0 ? -val : val;

  while(auxval<1 && auxval != 0.){
   auxval=auxval*10.;
   digspace+=1;
  }

  if(digspace+DEFAULT_PRECISION+1>intspace || digspace > DEFAULT_PRECISION){
    sprintf (label, "%*.*E", intspace, DEFAULT_PRECISION, val);
  }
  else
    {
    intspace=MIN(intspace, strlen(text)-digspace-1);
    sprintf (label, "%*.*f", intspace, DEFAULT_PRECISION, val);
    if(strlen(label) > space)
      sprintf (label, "%*.*E", intspace, DEFAULT_PRECISION, val);
  }

}
*/

// The following routine will convert the first number it finds in
// a string to an unsigned long integer. All of the hard work is done
// in the library function strtoul (string to unsigned long).

unsigned long get_number_in_string(char *number_string)
{
  unsigned long retval = 0;
  char *bad_position;
  int current_base = 16;


  errno = 0;

  retval = strtoul(number_string, &bad_position, current_base);

  if( strlen(bad_position) ) 
    errno = EINVAL;  /* string contains an invalid number */

  /*
  if(retval > 255)
    errno = ERANGE;
  */

  return(retval);
}

void
parse_numbers(GtkWidget *widget, gpointer data)
{
  GtkSheet *sheet;
  //  char label[400];
  gchar *text;
  gchar buf[5];
  int justification,n;

  if(gp == NULL)
    return;

  sheet=GTK_SHEET(widget);

  //justification = GTK_SHENTRY(sheet->sheet_entry)->justification;
  justification=GTK_JUSTIFY_RIGHT;

  /*
    format_text(sheet, &justification,
    gtk_entry_get_text(GTK_ENTRY(sheet->sheet_entry)), label);
  */

  if(sheet->active_cell.col < 16)
    {

      int reg = 16*sheet->active_cell.row + sheet->active_cell.col;

      text = gtk_entry_get_text(GTK_ENTRY(sheet->sheet_entry));

      errno = 0;
      if(strlen(text)>0)
	n = get_number_in_string(text);
      else
	errno = ERANGE;

      if(errno != 0)
	{
	  n = gp->p->registers[reg]->get_value();
	  gp->register_window->registers[reg]->value = -1;
	}



      if(gp->p->registers[reg]->isa() != file_register::INVALID_REGISTER) {
	gp->p->registers[reg]->put_value(n&0xff);
	sprintf(buf,"%02x",(n&0xff));
	gtk_sheet_set_cell(sheet, 
			   sheet->active_cell.row, 
			   sheet->active_cell.col, 
			   GTK_JUSTIFY_RIGHT,
			   buf);
      } else 
	gtk_sheet_set_cell(sheet, 
			   sheet->active_cell.row, 
			   sheet->active_cell.col, 
			   GTK_JUSTIFY_RIGHT,
			   "----");

    }
  else
    // ignore user changes in ascii column for right now
    update_ascii(gp->register_window,sheet->active_cell.row);

}


static void
clipboard_handler(GtkWidget *widget, GdkEventKey *key)
{
  GtkSheet *sheet;

  sheet = GTK_SHEET(widget);

  if(key->state & GDK_CONTROL_MASK || key->keyval==GDK_Control_L ||
     key->keyval==GDK_Control_R){
    if((key->keyval=='c' || key->keyval == 'C') && sheet->state != GTK_STATE_NORMAL){
            if(GTK_SHEET_IN_CLIP(sheet)) gtk_sheet_unclip_range(sheet);
            gtk_sheet_clip_range(sheet, sheet->range);
    }
    if(key->keyval=='x' || key->keyval == 'X')
            gtk_sheet_unclip_range(sheet);    
  }
}

static void 
resize_handler(GtkWidget *widget, GtkSheetRange *old_range, 
                                  GtkSheetRange *new_range, 
                                  gpointer data)
{
  /*
  printf("OLD SELECTION: %d %d %d %d\n",old_range->row0, old_range->col0,
                                    old_range->rowi, old_range->coli);
  printf("NEW SELECTION: %d %d %d %d\n",new_range->row0, new_range->col0,
                                    new_range->rowi, new_range->coli);
  */

}

static void 
move_handler(GtkWidget *widget, GtkSheetRange *old_range, 
                                  GtkSheetRange *new_range, 
                                  gpointer data)
{
  /*
  printf("OLD SELECTION: %d %d %d %d\n",old_range->row0, old_range->col0,
                                    old_range->rowi, old_range->coli);
  printf("NEW SELECTION: %d %d %d %d\n",new_range->row0, new_range->col0,
                                    new_range->rowi, new_range->coli);
  */

}
/*
void alarm_change(GtkWidget *widget, gint row, gint col, gpointer data)
{
 printf("CHANGE CELL: %d %d\n",row,col);
}
void alarm_activate(GtkWidget *widget, gint row, gint col, gpointer data)
{
 printf("ACTIVATE CELL: %d %d\n",row,col);
}
void alarm_deactivate(GtkWidget *widget, gint row, gint col, gpointer data)
{
 printf("DEACTIVATE CELL: %d %d\n",row,col);
}
gint alarm_traverse(GtkWidget *widget, gint row, gint col, gint *new_row, gint *new_col,
gpointer data)
{
 printf("TRAVERSE: %d %d %d %d\n",row,col,*new_row,*new_col);
 return TRUE;
}
*/

void
build_register_viewer(GtkWidget *widget)
{
	GtkSheet *sheet;
	GtkSheetRange range;
	GdkColor color;

	gchar name[10];
	gint i,j;
	gint border_mask, border_width, column_width,row_height,char_width;

	char_width = gdk_string_width (normal_style->font,"9");
	column_width = 3 * char_width + 6;

	sheet=GTK_SHEET(widget);

	for(i=0; i<sheet->maxcol; i++){
	  //sprintf(name,"0x%02x",i);
		sprintf(name,"%02x",i);
		gtk_sheet_column_button_add_label(sheet, i, name);
		gtk_sheet_set_column_title(sheet, i, name);
		gtk_sheet_set_column_width (sheet, i, column_width);
	}

	sprintf(name,"ASCII");
	gtk_sheet_column_button_add_label(sheet, i, name);
	gtk_sheet_set_column_title(sheet, i, name);
	gtk_sheet_set_column_width (sheet, i, 16*char_width + 6);

	gtk_sheet_set_row_titles_width(sheet, column_width);

	for(i=0; i<=sheet->maxrow; i++){
	  //sprintf(name,"0x%x0",i);
		sprintf(name,"%x0",i);
		gtk_sheet_row_button_add_label(sheet, i, name);
		gtk_sheet_set_row_title(sheet, i, name);
	}


	range.row0=0;
	range.rowi=255;
	range.col0=0;
	range.coli=16;


	gdk_color_alloc(gtk_widget_get_colormap(widget), &normal_bg_color );
	gdk_color_alloc(gtk_widget_get_colormap(widget), &normal_fg_color );
	gdk_color_alloc(gtk_widget_get_colormap(widget), &item_has_changed_color);
	gdk_color_alloc(gtk_widget_get_colormap(widget), &breakpoint_color);

	gtk_sheet_range_set_background(sheet, range, &normal_bg_color );
	
	gtk_sheet_range_set_foreground(sheet, range, &normal_fg_color );

	gtk_sheet_range_set_font(sheet, range, normal_style->font);

	border_mask = GTK_SHEET_RIGHT_BORDER | 
		GTK_SHEET_LEFT_BORDER |
		GTK_SHEET_BOTTOM_BORDER | 
		GTK_SHEET_TOP_BORDER;

	border_width = 1;

	gtk_sheet_range_set_border(sheet, range, border_mask, border_width, 0);

	border_mask = GTK_SHEET_LEFT_BORDER;
	border_width = 3;

	range.col0=16;
	range.coli=16;

	gtk_sheet_range_set_border(sheet, range, border_mask, border_width, 0);



	gtk_signal_connect(GTK_OBJECT(sheet),
			   "key_press_event",
			   (GtkSignalFunc) clipboard_handler, 
			   NULL);

	gtk_signal_connect(GTK_OBJECT(sheet),
			   "resize_range",
			   (GtkSignalFunc) resize_handler, 
			   NULL);

	gtk_signal_connect(GTK_OBJECT(sheet),
			   "move_range",
			   (GtkSignalFunc) move_handler, 
			   NULL);
/*
 gtk_signal_connect(GTK_OBJECT(sheet),
                    "changed",
                    (GtkSignalFunc) alarm_change, 
                    NULL);
 gtk_signal_connect(GTK_OBJECT(sheet),
                    "activate",
                    (GtkSignalFunc) alarm_activate, 
                    NULL);
 gtk_signal_connect(GTK_OBJECT(sheet),
                    "deactivate",
                    (GtkSignalFunc) alarm_deactivate, 
                    NULL);

	gtk_signal_connect(GTK_OBJECT(sheet),
			   "traverse",
			   (GtkSignalFunc) alarm_traverse, 
			   NULL);
*/
	gtk_signal_connect(GTK_OBJECT(sheet),
			   "button_press_event",
			   (GtkSignalFunc) do_popup, 
			   NULL);

 gtk_signal_connect(GTK_OBJECT(sheet),
	            "set_cell",
		    (GtkSignalFunc) parse_numbers,
                    NULL);                   


}

void
set_cell(GtkWidget *widget, gchar *insert, gint text_legth, gint position, 
         gpointer data)
{
  char *text;
  GtkEntry *sheet_entry;

  printf("set_cell\n");
  sheet_entry = GTK_ENTRY(gtk_sheet_get_entry(GTK_SHEET(widget)));

  if((text = gtk_entry_get_text (sheet_entry)))
    gtk_entry_set_text(GTK_ENTRY(entry), text);


  GTK_WIDGET_UNSET_FLAGS(entry, GTK_HAS_FOCUS);
  GTK_WIDGET_SET_FLAGS(GTK_SHEET(widget)->sheet_entry, GTK_HAS_FOCUS);
} 

void
show_sheet_entry(GtkWidget *widget, gpointer data)
{
 char *text;
 GtkSheet *sheet;
 GtkEntry *sheet_entry;

 if(!GTK_WIDGET_HAS_FOCUS(widget)) return;

 sheet=GTK_SHEET(register_sheet);
 sheet_entry = GTK_ENTRY(gtk_sheet_get_entry(sheet));

 if((text=gtk_entry_get_text (GTK_ENTRY(entry))))
   gtk_entry_set_text(sheet_entry, text);

}

void 
activate_sheet_entry(GtkWidget *widget, gpointer data)
{
  GtkSheet *sheet;
  GtkEntry *sheet_entry;

  gint row, col;
  gint justification=GTK_JUSTIFY_RIGHT;
  
  sheet=GTK_SHEET(register_sheet);
  row=sheet->active_cell.row; col=sheet->active_cell.col;

  sheet_entry = GTK_ENTRY(gtk_sheet_get_entry(sheet));

  //  if(GTK_IS_SHENTRY(sheet_entry))
  //       justification = GTK_SHENTRY(sheet_entry)->justification;

  gtk_sheet_set_cell(sheet, row, col,
		     justification,
		     gtk_entry_get_text (sheet_entry));

}

void 
show_entry(GtkWidget *widget, gpointer data)
{
 char *text; 
 GtkSheet *sheet;
 GtkWidget * sheet_entry;

 if(!GTK_WIDGET_HAS_FOCUS(widget)) return;

 sheet=GTK_SHEET(register_sheet);
 sheet_entry = gtk_sheet_get_entry(sheet);

 if((text=gtk_entry_get_text (GTK_ENTRY(sheet_entry))))
	 gtk_entry_set_text(GTK_ENTRY(entry), text);

}

#ifdef USE_DEMO_TOOLBAR

void 
justify_left(GtkWidget *widget)
{
  GtkSheet *current;

  current=GTK_SHEET(register_sheet);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(left_button),
  GTK_STATE_ACTIVE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(right_button),
  GTK_STATE_NORMAL);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(center_button),
  GTK_STATE_NORMAL);


  gtk_sheet_range_set_justification(current, current->range,
  GTK_JUSTIFY_LEFT);
}

void 
justify_center(GtkWidget *widget) 
{
  GtkSheet *current;

  current=GTK_SHEET(register_sheet);


  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(center_button),
  GTK_STATE_ACTIVE);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(right_button),
  GTK_STATE_NORMAL);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(left_button),
  GTK_STATE_NORMAL);

  gtk_sheet_range_set_justification(current, current->range,
  GTK_JUSTIFY_CENTER);
}

void 
justify_right(GtkWidget *widget) 
{
  GtkSheet *current;

  current=GTK_SHEET(register_sheet);


  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(right_button),
  GTK_STATE_ACTIVE);

  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(left_button),
  GTK_STATE_NORMAL);

  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(center_button),
  GTK_STATE_NORMAL);

  gtk_sheet_range_set_justification(current, current->range,
  GTK_JUSTIFY_RIGHT);
}
#endif

gint
activate_sheet_cell(GtkWidget *widget, gint row, gint column, Register_Window *rw) 
{
  GtkSheet *sheet;
  GtkEntry *sheet_entry;
  char cell[100];
  char *text;
  GtkSheetCellAttr attributes;
  pic_processor *pic;


  sheet=GTK_SHEET(widget);
  sheet_entry = GTK_ENTRY(gtk_sheet_get_entry(sheet));

  cell[0] = 0;
  if(rw->gui_obj.gp)
    {
      pic = rw->gui_obj.gp->p;
      if(pic) 
	{
	if(column < 16)
	  sprintf(cell," %s  ", pic->registers[16*row+column]->name());
	else
	  sprintf(cell," ascii  ");
	}
    }
  else
    sprintf(cell," 0x%02x  ", 16*row+column);

  gtk_label_set(GTK_LABEL(location), cell);

  gtk_entry_set_max_length(GTK_ENTRY(entry),
	GTK_ENTRY(sheet_entry)->text_max_length);

  if((text=gtk_entry_get_text(GTK_ENTRY(gtk_sheet_get_entry(sheet)))))
    gtk_entry_set_text(GTK_ENTRY(entry), text);
  else
    gtk_entry_set_text(GTK_ENTRY(entry), "");


  gtk_sheet_get_attributes(sheet,sheet->active_cell.row,
				sheet->active_cell.col, &attributes);

  gtk_entry_set_editable(GTK_ENTRY(entry), attributes.is_editable);

#ifdef USE_DEMO_TOOLBAR
  switch (attributes.justification){
    case GTK_JUSTIFY_LEFT:
         justify_left(NULL);
	 break;
    case GTK_JUSTIFY_CENTER:
         justify_center(NULL);
	 break;
    case GTK_JUSTIFY_RIGHT:
         justify_right(NULL);
	 break;
    default:
         justify_left(NULL);
	 break;
  }
#endif

  gtk_sheet_range_set_justification(sheet, sheet->range,
  GTK_JUSTIFY_RIGHT);

  return TRUE;
}

#ifdef USE_DEMO_TOOLBAR

void 
change_border (GtkWidget *widget, gint border)
{
   GtkSheet *current;
   GtkSheetRange range, auxrange;
   gint border_mask, border_width=1;
   gint auxcol, auxrow;
   gint i,j;

   current=GTK_SHEET(register_sheet);

   range=current->range;

   gtk_sheet_range_set_border(current, range, 0, 0, 0);

   switch(border){
     case 0:
       break;
     case 1:
       border_mask = GTK_SHEET_TOP_BORDER;
       range.rowi = range.row0;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 2:
       border_mask = GTK_SHEET_BOTTOM_BORDER;
       range.row0 = range.rowi;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 3:
       border_mask = GTK_SHEET_RIGHT_BORDER;
       range.col0 = range.coli;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 4:
       border_mask = GTK_SHEET_LEFT_BORDER;
       range.coli = range.col0;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 5:
       if(range.col0 == range.coli){
	   border_mask = GTK_SHEET_LEFT_BORDER | GTK_SHEET_RIGHT_BORDER;
	   gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
           break;
	}
       border_mask = GTK_SHEET_LEFT_BORDER;
       auxcol=range.coli;
       range.coli = range.col0;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       border_mask = GTK_SHEET_RIGHT_BORDER;
       range.col0 = range.coli=auxcol; 
       gtk_sheet_range_set_border(current,range, border_mask, border_width, 0);
       break;
     case 6:
       if(range.row0 == range.rowi){
	   border_mask = GTK_SHEET_TOP_BORDER | GTK_SHEET_BOTTOM_BORDER;
	   gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
           break;
	}
       border_mask = GTK_SHEET_TOP_BORDER;
       auxrow=range.rowi;
       range.rowi = range.row0;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       border_mask = GTK_SHEET_BOTTOM_BORDER;
       range.row0=range.rowi=auxrow; 
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 7:
       border_mask = GTK_SHEET_RIGHT_BORDER | GTK_SHEET_LEFT_BORDER;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 8:
       border_mask = GTK_SHEET_BOTTOM_BORDER | GTK_SHEET_TOP_BORDER;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;
     case 9:
       gtk_sheet_range_set_border(current, range, 15, border_width, 0);
       for(i=range.row0; i<=range.rowi; i++)
        for(j=range.col0; j<=range.coli; j++){
          border_mask = 15;
          auxrange.row0 = i;
          auxrange.rowi = i;
          auxrange.col0 = j;
          auxrange.coli = j;
          if(i == range.rowi) border_mask ^= GTK_SHEET_BOTTOM_BORDER;
          if(i == range.row0) border_mask ^= GTK_SHEET_TOP_BORDER;
          if(j == range.coli) border_mask ^= GTK_SHEET_RIGHT_BORDER;
          if(j == range.col0) border_mask ^= GTK_SHEET_LEFT_BORDER;
          if(border_mask != 15)
            gtk_sheet_range_set_border(current, auxrange, border_mask, 
                                       border_width, 0);
       }

       break;
     case 10:
       for(i=range.row0; i<=range.rowi; i++)
        for(j=range.col0; j<=range.coli; j++){
          border_mask = 0;
          auxrange.row0 = i;
          auxrange.rowi = i;
          auxrange.col0 = j;
          auxrange.coli = j;
          if(i == range.rowi) border_mask |= GTK_SHEET_BOTTOM_BORDER;
          if(i == range.row0) border_mask |= GTK_SHEET_TOP_BORDER;
          if(j == range.coli) border_mask |= GTK_SHEET_RIGHT_BORDER;
          if(j == range.col0) border_mask |= GTK_SHEET_LEFT_BORDER;
          if(border_mask != 0)
            gtk_sheet_range_set_border(current, auxrange, border_mask, 
                                       border_width, 0);
       }

       break;
     case 11:
       border_mask = 15;
       gtk_sheet_range_set_border(current, range, border_mask, border_width, 0);
       break;


   }

}


void 
change_fg(GtkWidget *widget, gint i, gchar *color_name)
{
   GtkSheet *current;
   GdkColor color;

   GdkGC *tmp_gc;

   current=GTK_SHEET(register_sheet);

   gdk_color_parse(color_name, &color);
   gdk_color_alloc(gtk_widget_get_colormap(widget), &color);
   gtk_sheet_range_set_foreground(current, current->range, &color);

   tmp_gc=gdk_gc_new(window->window);
   gdk_gc_set_foreground(tmp_gc,&color);
   gdk_draw_rectangle(GTK_PIXMAP(fg_pixmap)->pixmap,
		      tmp_gc, TRUE, 5,20,16,4);
   gtk_widget_queue_draw(fg_pixmap); gdk_gc_unref(tmp_gc);
}

void 
change_bg(GtkWidget *widget, gint i, gchar *color_name)
{
   GtkSheet *current;
   GdkColor color;
   GdkGC *tmp_gc;

   current=GTK_SHEET(register_sheet);

   gdk_color_parse(color_name, &color);
   gdk_color_alloc(gtk_widget_get_colormap(widget), &color);
   gtk_sheet_range_set_background(current, current->range, &color);

   tmp_gc=gdk_gc_new(window->window);
   gdk_gc_set_foreground(tmp_gc,&color);
   gdk_draw_rectangle(GTK_PIXMAP(bg_pixmap)->pixmap,
		      tmp_gc, TRUE, 5,21,18,4);
   gtk_widget_queue_draw(bg_pixmap); gdk_gc_unref(tmp_gc);

}

void 
do_hide_row_titles(GtkWidget *widget) 
{
  GtkSheet *current;

  current=GTK_SHEET(register_sheet);

  gtk_sheet_hide_row_titles(current);
}

void 
do_hide_column_titles(GtkWidget *widget) 
{
  GtkSheet *current; 

  current=GTK_SHEET(register_sheet);

  gtk_sheet_hide_column_titles(current);
}

void 
do_show_row_titles(GtkWidget *widget) 
{
  GtkSheet *current; 

  current=GTK_SHEET(register_sheet);

  gtk_sheet_show_row_titles(current);
}

void 
do_show_column_titles(GtkWidget *widget) 
{
  GtkSheet *current; 

  current=GTK_SHEET(register_sheet);

  gtk_sheet_show_column_titles(current);
}

#endif

static void 
do_quit_app(GtkWidget *widget) 
{
	exit_gpsim();
}

#ifdef USE_DEMO_TOOLBAR

void
build_show_hide_buttons(GtkWidget *main_vbox)
{

  GtkWidget *hide_row_titles;
  GtkWidget *hide_column_titles; 
  GtkWidget *show_row_titles; 
  GtkWidget *show_column_titles;
  GtkWidget *quit_app;

  show_hide_box = gtk_hbox_new(FALSE, 1); 
  hide_row_titles = gtk_button_new_with_label("Hide Row Titles"); 
  hide_column_titles = gtk_button_new_with_label("Hide Column Titles"); 
  show_row_titles = gtk_button_new_with_label("Show Row Titles"); 
  show_column_titles = gtk_button_new_with_label("Show Column Titles");
  quit_app = gtk_button_new_with_label("QUIT");

  gtk_box_pack_start(GTK_BOX(show_hide_box), hide_row_titles, TRUE, TRUE, 0); 
  gtk_box_pack_start(GTK_BOX(show_hide_box), hide_column_titles, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(show_hide_box), show_row_titles, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(show_hide_box), show_column_titles, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(show_hide_box), quit_app, TRUE, TRUE, 0);

  gtk_widget_show(hide_row_titles); 
  gtk_widget_show(hide_column_titles);
  gtk_widget_show(show_row_titles); 
  gtk_widget_show(show_column_titles);
  gtk_widget_show(quit_app);

  gtk_signal_connect(GTK_OBJECT(hide_row_titles), "clicked",
		     (GtkSignalFunc) do_hide_row_titles, NULL);

  gtk_signal_connect(GTK_OBJECT(hide_column_titles), "clicked",
		     (GtkSignalFunc) do_hide_column_titles, NULL);

  gtk_signal_connect(GTK_OBJECT(show_row_titles), "clicked",
		     (GtkSignalFunc) do_show_row_titles, NULL);

  gtk_signal_connect(GTK_OBJECT(show_column_titles), "clicked",
		     (GtkSignalFunc) do_show_column_titles, NULL);

  gtk_signal_connect(GTK_OBJECT(quit_app), "clicked",
		     (GtkSignalFunc) do_quit_app, NULL);


  gtk_box_pack_start(GTK_BOX(main_vbox), show_hide_box, FALSE, TRUE, 0);
  gtk_widget_show(show_hide_box);


}





void
build_tool_bar(GtkWidget *main_vbox)
{
  toolbar=gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,  
			  (GtkToolbarStyle)GTK_TOOLBAR_CHILD_WIDGET);

  left_button = gtk_toggle_button_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    left_button, "justify left", "justify left");
  gtk_widget_show(left_button);
  gtk_signal_connect(GTK_OBJECT(left_button),"released",
		     (GtkSignalFunc) justify_left, NULL);

  center_button = gtk_toggle_button_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    center_button, "justify center", "justify center");
  gtk_widget_show(center_button);
  gtk_signal_connect(GTK_OBJECT(center_button), "released",
		     (GtkSignalFunc) justify_center, NULL);

  right_button = gtk_toggle_button_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    right_button, "justify right", "justify right");
  gtk_widget_show(right_button);
  gtk_signal_connect(GTK_OBJECT(right_button), "released",
		     (GtkSignalFunc) justify_right, NULL);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  bordercombo=gtk_border_combo_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    bordercombo, "border", "border");
  gtk_widget_set_usize(GTK_COMBO_BOX(bordercombo)->button, 32, 32);
  gtk_widget_show(bordercombo);

  gtk_signal_connect(GTK_OBJECT(bordercombo),
		     "changed", (GtkSignalFunc)change_border, NULL);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  fgcolorcombo=gtk_color_combo_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    fgcolorcombo, "font color", "font color");
  gtk_widget_show(fgcolorcombo);
  gtk_signal_connect(GTK_OBJECT(fgcolorcombo),
		     "changed", (GtkSignalFunc)change_fg, NULL);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  bgcolorcombo=gtk_color_combo_new();
  gtk_toolbar_append_widget(GTK_TOOLBAR(toolbar),
			    bgcolorcombo, "background color", "background
			    color");
  gtk_widget_show(bgcolorcombo);
  gtk_signal_connect(GTK_OBJECT(bgcolorcombo),
		     "changed", (GtkSignalFunc)change_bg, NULL);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_box_pack_start(GTK_BOX(main_vbox), toolbar, FALSE, TRUE, 0);
  gtk_widget_show(toolbar);
}


#endif

void
build_status_bar(GtkWidget *main_vbox)
{
  GtkRequisition request; 

  status_box=gtk_hbox_new(FALSE, 1);
  gtk_container_set_border_width(GTK_CONTAINER(status_box),0);
  gtk_box_pack_start(GTK_BOX(main_vbox), status_box, FALSE, TRUE, 0);
  gtk_widget_show(status_box);

  location=gtk_label_new(""); 
  gtk_widget_size_request(location, &request); 
  gtk_widget_set_usize(location, 160, request.height);
  gtk_box_pack_start(GTK_BOX(status_box), location, FALSE, TRUE, 0);
  gtk_widget_show(location);

  entry=gtk_entry_new(); 
  gtk_box_pack_start(GTK_BOX(status_box), entry,
		     TRUE, TRUE, 0); 
  gtk_widget_show(entry);

}

void update_ascii(Register_Window *rw, gint row)
{
  gint i,reg_number;
  gchar name[32];

  for(i=0; i<16; i++)
    {

      name[i] = rw->registers[16*row + i]->value;

      if( (name[i] < ' ') || (name[i]>'z'))
	name[i] = '.';

    }

  name[16] = 0;

  gtk_sheet_set_cell(GTK_SHEET(rw->register_sheet), row,16, GTK_JUSTIFY_RIGHT,name);

}

void assign_register_value(Register_Window *rw, unsigned int reg_number,unsigned int value)
{
  gchar name[16];
  gint current_value;
  pic_processor *pic;


  if(reg_number > 255)
    return;

  pic = rw->gui_obj.gp->p;

  if( !((pic->registers[reg_number]->isa() == file_register::SFR_REGISTER) ||
	(pic->registers[reg_number]->isa() == file_register::FILE_REGISTER) ) )
    return;
  
  
  current_value = pic->registers[reg_number]->get_value();

  if(value > 255)
    value = current_value;
      
  // Write the value to the register and then read it back.
  // This is necessary because some registers have read only bits.

  pic->registers[reg_number]->put_value(value);
  value = rw->registers[reg_number]->value  = pic->registers[reg_number]->get_value();

  //sprintf (name, "0x%02x", value);
  sprintf (name, "%02x", value);
  gtk_sheet_set_cell(GTK_SHEET(rw->register_sheet),
		     rw->registers[reg_number]->row, 
		     rw->registers[reg_number]->col, 
		     GTK_JUSTIFY_RIGHT,name);

  update_ascii(rw,rw->registers[reg_number]->row);

}

void RegWindow_update_register(Register_Window *rw, unsigned int reg_number)
{
  gchar name[16];
  gint new_value;
  pic_processor *pic;
  GtkSheetRange range;

  if(reg_number > 4095)
    return;



  pic = gp->p;

  if( !((pic->registers[reg_number]->isa() == file_register::SFR_REGISTER) ||
	(pic->registers[reg_number]->isa() == file_register::FILE_REGISTER) ||
	(pic->registers[reg_number]->isa() == file_register::BP_REGISTER)
	) )
    return;
  
  
  new_value = pic->registers[reg_number]->get_value();

  range.row0=rw->registers[reg_number]->row;
  range.rowi=rw->registers[reg_number]->row;
  range.col0=rw->registers[reg_number]->col;
  range.coli=rw->registers[reg_number]->col;

  if(new_value != rw->registers[reg_number]->value) {

    rw->registers[reg_number]->value = new_value;
    //sprintf (name, "0x%02x", new_value);
    sprintf (name, "%02x", new_value);

    gtk_sheet_set_cell(GTK_SHEET(rw->register_sheet),
		       rw->registers[reg_number]->row, 
		       rw->registers[reg_number]->col, 
		       GTK_JUSTIFY_RIGHT,name);


    gtk_sheet_range_set_foreground(GTK_SHEET(rw->register_sheet), range, &item_has_changed_color);


    update_ascii(rw,rw->registers[reg_number]->row);

  }

  if(pic->registers[reg_number]->isa() == file_register::BP_REGISTER)
    gtk_sheet_range_set_background(GTK_SHEET(rw->register_sheet), range, &breakpoint_color);
}


void RegWindow_update(Register_Window *rw)
{
  GtkSheetRange range;

  gtk_sheet_freeze (rw->register_sheet);


  range.row0=0;
  range.rowi=255;
  range.col0=0;
  range.coli=16;

  gtk_sheet_range_set_background(GTK_SHEET(rw->register_sheet), range, &normal_style->base[GTK_STATE_NORMAL]);

  gtk_sheet_range_set_foreground(GTK_SHEET(rw->register_sheet), range, &normal_style->fg[GTK_STATE_NORMAL]);


  for(int i = 0; i<4096; i++)
    RegWindow_update_register(rw, i);

  gtk_sheet_thaw (rw->register_sheet);

}


void RegWindow_update_cell(cross_reference_to_gui *xref, int new_value)
{
  Register *reg;
  Register_Window *rw;
  char name[16];

  reg = (Register *) (xref->data);
  rw  = (Register_Window *) (xref->parent_window);

  if(reg->value != new_value)
    {

      reg->value = new_value;
      //sprintf (name, "0x%02x", new_value);
      sprintf (name, "%02x", new_value);

      gtk_sheet_set_cell(GTK_SHEET(rw->register_sheet),
			 reg->row, 
			 reg->col, 
			 GTK_JUSTIFY_RIGHT,name);

      update_ascii(rw,reg->row);
    }
  
}

void RegWindow_new_processor(Register_Window *rw, GUI_Processor *gp)
{



  gchar name[32];
  gint i,j,reg_number;
  GtkSheet *sheet;
  pic_processor *pic;
  cross_reference_to_gui  *cross_reference;
  gboolean all_invalid;

  if(rw == NULL || gp == NULL)
    return;

  rw->gui_obj.gp = gp;
  gp->register_window = rw;
  pic = gp->p;

  rw->registers = (Register  **)malloc(4096*sizeof(Register *));

  sheet=GTK_SHEET(rw->register_sheet);
  gtk_sheet_freeze (sheet);

  for(j=0; j<256; j++)
    {
      all_invalid = TRUE;

      for(i=0; i<16; i++)
	{
	  reg_number = 16*j + i;

	  rw->registers[reg_number] = (Register  *)malloc(sizeof(Register));
	  rw->registers[reg_number]->row = j;
	  rw->registers[reg_number]->col = i;
	  rw->registers[reg_number]->value = -1;

	  if( (pic->registers[reg_number]->isa() == file_register::SFR_REGISTER) ||
	      (pic->registers[reg_number]->isa() == file_register::FILE_REGISTER) ) {

	    rw->registers[reg_number]->value = pic->registers[reg_number]->get_value();
	    //sprintf (name, "0x%02x", rw->registers[reg_number]->value);
	    sprintf (name, "%02x", rw->registers[reg_number]->value);

	    /* Now create a cross-reference link that the simulator can use to
	     * send information back to the gui
	     */

	    cross_reference = (cross_reference_to_gui *) malloc(sizeof(cross_reference_to_gui));
	    cross_reference->parent_window_type =   WT_register_window;
	    cross_reference->parent_window = (gpointer) rw;
	    cross_reference->data = (gpointer) rw->registers[reg_number];
	    cross_reference->update = RegWindow_update_cell;

	    pic->registers[reg_number]->assign_xref((gpointer) cross_reference);
	    all_invalid = FALSE;
	  }
	  else

	    sprintf (name, "----");

	  gtk_sheet_set_cell(sheet, j,i, GTK_JUSTIFY_RIGHT,name);

	}

      update_ascii(rw,j);
      if(all_invalid)
	gtk_sheet_set_row_height (sheet,j,0);

    }


  gtk_sheet_thaw (sheet);



  RegWindow_update(rw);

}

static int
RegisterWindow_close(GtkWidget *widget,
		    Register_Window *rw)
{

  SourceBrowser_change_view((GUI_Object *)rw,0);

  return(TRUE);

}


GtkWidget *CreateRegisterWindow(GUI_Processor *gp)
{
  GtkWidget *main_vbox;
  GtkWidget *scrolled_window;
  GtkWidget *separator;
  GtkWidget *hbox;
  GtkWidget *button;

#define MAXROWS  256
#define MAXCOLS  16+1

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "register viewer");
  //  gtk_widget_set_usize(GTK_WIDGET(window), 100, 100);
  gtk_window_set_default_size(GTK_WINDOW(window), 600, 400);

  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroyed), &window);
  //GTK_SIGNAL_FUNC (quit), NULL);

  main_vbox=gtk_vbox_new(FALSE,1);
  gtk_container_set_border_width(GTK_CONTAINER(main_vbox),0); 
  gtk_container_add(GTK_CONTAINER(window), main_vbox);
  gtk_widget_show(main_vbox);

  //build_show_hide_buttons(main_vbox);
  //create_handle_box(main_vbox);
#ifdef USE_DEMO_TOOLBAR
  build_tool_bar(main_vbox);
#endif
  build_status_bar(main_vbox);

  register_sheet=gtk_sheet_new(MAXROWS,MAXCOLS,"gpsim Register Viewer");
  register_window = (Register_Window *)malloc(sizeof(Register_Window));
  register_window->register_sheet = GTK_SHEET(register_sheet);
  //  register_window->gui_obj.gp = NULL;
  register_window->registers = NULL;

  register_window->gui_obj.window = window;
  register_window->gui_obj.gp = gp;
  register_window->gui_obj.name = "Register Viewer";
  register_window->gui_obj.wc = WC_data;
  register_window->gui_obj.change_view = SourceBrowser_change_view;

  gp->register_window = register_window;
  gp_add_window_to_list(gp, (GUI_Object *)register_window);


  scrolled_window=gtk_scrolled_window_new(NULL, NULL);

  gtk_container_add(GTK_CONTAINER(scrolled_window), register_sheet);

  gtk_widget_show(register_sheet);
  gtk_widget_show(scrolled_window);

  gtk_box_pack_start(GTK_BOX(main_vbox), scrolled_window, TRUE, TRUE, 0);

  status_bar_window = (StatusBar_Window *)malloc(sizeof(StatusBar_Window));
  StatusBar_create(main_vbox,status_bar_window);

  gtk_signal_connect(GTK_OBJECT(gtk_sheet_get_entry(GTK_SHEET(register_sheet))),
		     "changed", (GtkSignalFunc)show_entry, NULL);

  gtk_signal_connect(GTK_OBJECT(register_sheet),
		     "activate", (GtkSignalFunc)activate_sheet_cell,
		     (gpointer) register_window);

  gtk_signal_connect(GTK_OBJECT(entry),
		     "changed", (GtkSignalFunc)show_sheet_entry, NULL);

  gtk_signal_connect(GTK_OBJECT(entry),
		     "activate", (GtkSignalFunc)activate_sheet_entry,
		     NULL);

  gtk_widget_realize(window);

  build_register_viewer(register_sheet); 


  //  gtk_signal_connect(GTK_OBJECT(gtk_sheet_get_entry(GTK_SHEET(sheets[2]))),
  //		     "changed", (GtkSignalFunc)show_entry, NULL);

#ifdef USE_DEMO_TOOLBAR

  //
  // note. The pixmaps are installed in the 'DATADIR' directory.
  // This directory is ascertained by .configure and make install.
  // Once it's determined, it's passed to the compiler via a command
  // line option (-D DATADIR=\"$(DATADIR)/\" ). This simply creates
  // an old fashioned char string containing the path of the xpms.
  //

  pixmap=gdk_pixmap_create_from_xpm(window->window, &mask,
				    &window->style->bg[GTK_STATE_NORMAL],
				    DATADIR "left.xpm");
  tpixmap = gtk_pixmap_new(pixmap, mask);
  gtk_container_add(GTK_CONTAINER(left_button), tpixmap);
  gtk_widget_show(tpixmap);

  pixmap=gdk_pixmap_create_from_xpm(window->window, &mask,
				    &window->style->bg[GTK_STATE_NORMAL],
				    DATADIR "center.xpm");
  tpixmap = gtk_pixmap_new(pixmap, mask);
  gtk_container_add(GTK_CONTAINER(center_button), tpixmap);
  gtk_widget_show(tpixmap);

  pixmap=gdk_pixmap_create_from_xpm(window->window, &mask,
				    &window->style->bg[GTK_STATE_NORMAL],
				    DATADIR "right.xpm");
  tpixmap = gtk_pixmap_new(pixmap, mask);
  gtk_container_add(GTK_CONTAINER(right_button), tpixmap);
  gtk_widget_show(tpixmap);


  pixmap=gdk_pixmap_create_from_xpm(window->window, &mask,
				    &window->style->bg[GTK_STATE_NORMAL],
				    DATADIR "paint.xpm");

  bg_pixmap=gtk_pixmap_new(pixmap, mask);
  gtk_container_add(GTK_CONTAINER(GTK_COMBO_BOX(bgcolorcombo)->button),
		    bg_pixmap);

  gtk_widget_show(bg_pixmap);

  pixmap=gdk_pixmap_create_from_xpm(window->window, &mask,
				    &window->style->bg[GTK_STATE_NORMAL],
				    DATADIR "font.xpm");


  fg_pixmap=gtk_pixmap_new(pixmap, mask);
  gtk_container_add(GTK_CONTAINER(GTK_COMBO_BOX(fgcolorcombo)->button),
		    fg_pixmap);

  gtk_widget_show(fg_pixmap);
#endif

  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (main_vbox), separator, FALSE, TRUE, 0);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (main_vbox), hbox, FALSE, TRUE, 0);

  button = gtk_button_new_with_label ("close");
  gtk_container_set_border_width (GTK_CONTAINER (button), 10);
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC(RegisterWindow_close),
		      (gpointer) register_window);


  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);


  gtk_widget_show_all (window);

  //gtk_widget_show(window);

  return(window);
}



