/*
   Copyright (C) 1998 T. Scott Dattalo

This file is part of gpsim.

gpsim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gpsim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gpasm; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>

//#include "14bit-registers.h"
//#include "14bit-instructions.h"
#include "16bit-processors.h"

#include <string>
#include "stimuli.h"


//-------------------------------------------------------------------
void _16bit_processor :: create_sfr_map(void)
{
  cout << "creating 18cxxx common registers\n";

  add_file_registers(0x0, 0xf7f, 0);


  add_sfr_register(&status,       0xfd8);
  add_sfr_register(&bsr,          0xfe0,0,"bsr");
  add_sfr_register(&W,            0xfe8);
  add_sfr_register(&ind0.fsrl,	  0xfe9,0,"fsr0l");
  add_sfr_register(&ind0.fsrh,    0xfea,0,"fsr0h");
  add_sfr_register(&ind0.plusw,   0xfeb,0,"plusw0");
  add_sfr_register(&ind0.preinc,  0xfec,0,"preinc0");
  add_sfr_register(&ind0.postdec, 0xfed,0,"postdec0");
  add_sfr_register(&ind0.postinc, 0xfee,0,"postinc0");
  add_sfr_register(&ind0.indf,    0xfef,0,"indf0");


  add_sfr_register(&pcl,    0xff9);
  add_sfr_register(&pclath, 0xffa);
  //add_sfr_register(&pclatu, 0xffb);

  add_sfr_register(&((Stack16 *)stack)->stkptr,  0xffc,0,"stkptr");
  add_sfr_register(&((Stack16 *)stack)->tosl,    0xffd,0,"tosl");
  add_sfr_register(&((Stack16 *)stack)->tosh,    0xffe,0,"tosh");
  add_sfr_register(&((Stack16 *)stack)->tosu,    0xfff,0,"tosu");


}

//-------------------------------------------------------------------
//
// 
//    create
//
//  The purpose of this member function is to 'create' those things
// that are unique to the 16-bit core processors.

void _16bit_processor :: create (void)
{

  //create_iopin_map(&iopin_map, &num_of_iopins);
  //create_iopins(iopin_map, num_of_iopins);

  sfr_map = NULL;
  num_of_sfrs = 0;
 

  pic_processor::create();

  _16bit_processor::create_sfr_map();

  fast_stack.init(this);
  ind0.init(this);
  ind0.init(this);
  ind0.init(this);
  trace.program_counter (pc.value);


}

//
// create_symbols
//
//  Create symbols for a generic 16-bit core. This allows symbolic
// access to the pic. (e.g. It makes it possible to access the 
// status register by name instead of by its address.)
//

void _16bit_processor::create_symbols (void)
{

  cout << "16bit create symbols\n";

}


//-------------------------------------------------------------------
void _16bit_processor::
interrupt (void)
{
  
  bp.clear_interrupt();

  stack->push(pc.value);
  intcon->clear_gie();

  pc.jump(INTERRUPT_VECTOR);

}

//-------------------------------------------------------------------
void _16bit_processor::por(void)
{
  pic_processor::por();
}

//-------------------------------------------------------------------
void _16bit_processor::option_new_bits_6_7(unsigned int bits)
{

  //portb.rbpu_intedg_update(bits);
  cout << "16bit, option bits 6 and/or 7 changed\n";

}

