/*
   Copyright (C) 1998 T. Scott Dattalo

This file is part of gpsim.

gpsim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gpsim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gpsim; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#include <stdio.h>
#include <iostream.h>
#include <string>

#include "symbol.h"

#include "p18x.h"



void P18Cxx2::create_sfr_map(void)
{

#define UNKNOWN  0

  const SFR_map sm[] =
  {
    {0x00, &indf, UNKNOWN},
    {0x80, &indf, UNKNOWN},

    {0x01, &tmr0, UNKNOWN},
    {0x81, &option_reg, 0xff},

    {0x02, &pcl, 0},
    {0x82, &pcl, 0},

    {0x03, &status, 0x18},
    {0x83, &status, 0x18},

    {0x04, &fsr, UNKNOWN},
    {0x84, &fsr, UNKNOWN},

    {0x0a, &pclath, 0},
    {0x8a, &pclath, 0},

  };


  // Create a place for permanently storing the special function register mapping.

  sfr_map = (SFR_map *) new char[sizeof (sm)];

  num_of_sfrs = 3;//sizeof (sm) / sizeof (SFR_map);

  // Save the SFR's.
  for(int i=0; i<num_of_sfrs; i++)
    sfr_map[i] = sm[i];

}

void P18Cxx2::create_symbols(void)
{
  cout << "8x create symbols\n";

}

//========================================================================
//
// Pic 18C
//


P18Cxx2::P18Cxx2(void)
{
  cout << "18c constructor, type = " << isa() << '\n';
  static GPR_map gm[] =
  {
    {0x0c, 0x2f, 0x80}
  };

  gpr_map = gm;
  num_of_gprs = sizeof (gm) / sizeof (GPR_map);
  
  create_sfr_map();
  //  create_iopin_map(&iopin_map, &num_of_iopins);

  _16bit_processor::create();

  //  create_iopins(iopin_map, num_of_iopins);

  name_str = "18cxx2";
  cout << "Program Memory size " <<  program_memory_size() << '\n';
}




